# Piknik Details
In order to demonstrate the practical use of this interaction method, and how it may complement or replace existing ones, we will be building a photo browser + drawing tool. Due to availability of hardware and software resources and platform familiarity, the application will be targeting android devices. The type and location of magnetometer can differ on each device \cite{CNS14}. Due to this and the variability of the magnetometer readings, we will be focusing on android smartphones with similar dimensions. Depending on the variability, we might need to take screen dimensions and magnetometer types into account.

Piknik will allow the user to select a directory to browse for an image. The user will be able to browse through all the images in this directory and select one to manipulate. Once a single image has been opened the user can make basic transformations (e.g. rotating and flipping the image), basic edits (e.g. cropping and resizing), and draw strokes on top of the image or insert text boxes. 

We will be incorporating both touch and magnet based interactions within Piknik. When browsing through the gallery, the user can use simple magnet based gestures to pan through the list of images found in the current directory. These magnet based gestures will include generic swipe left and right gestures to move the images left and right. To open the image, the user would have to tap directly on the device. An alternative method is to use the magnet as a pointer for the device but we believe this would not be possible due to the difficulty of detecting absolute position of the magnet over the phone \cite{CNS14}.

While editing an image, the user will use magnet based gestures to perform simple manipulations such as rotating, mirroring, drawing, and starting specific editing modes such as text entry for notes. To rotate the image, the user can select a point of reference by touch and use the magnet above the screen to "physically" rotate the image in reference to the point. To start specific text entry, the user can either manually tap on the photo or perform a pre-defined gesture using the magnet.

The user will be allowed to draw strokes onto the image, but in order to facilitate natural drawing and stylus support this will use the capacitive touchscreen of the device. However, the user will be able to adjust the stroke width by introducing different size magnets or by varying the distance of a magnet to the device. The goal is to implement the interaction effectively such that the user is able to use touch and gesture together in a way that proves more natural and efficient than either interaction method alone \cite{Ryokai_2004}. 

To facilitate combining touch and magnet based interactions, the user will have an option to switch to magnet + touch input on the screen. When the user is in touch mode, the user will only be able to provide touch input within the application. If the user has selected magnet mode, both magnet and touch input will be enabled. This will allow seamless interaction between touch + magnet interactions. However if the user would not like magnet interference, regular touch only input is available. An alternative method of toggling between magnet based interactions that we will look into is using magnet based gestures. A specific gesture can toggle between the two modes. However these gestures should not be easily reproducible as to not allow false triggering of magnet input. This is an area we will need to look into going forward with the project. 

We will also be looking into support for multiple magnets. At this time, it seems like this would be a huge undertaking since the magnetometer only reads the total magnetic field around the device. This means that without any prior knowledge, there doesn't seem to be any reliable way to tell if the changes in the magnetic filed are due to multiple magnets or a single larger one etc. That being said, Magnetic Marionette \cite{Hwang_2013} seems to be using a combination of magnets in some way, so this will definitely be kept in mind and investigated further as the project progresses.

We believe there is tremendous opportunity in displaying the various magnet based and touch interactions in a photo browser application. We hope to seamlessly integrate the two interactions where it's natural and not cumbersome to the user.